#include "StdAfx.h"
#include "DummySource.h"

//WłȂfBA^Cv
#define INITGUID
DEFINE_GUID(MEDIASUBTYPE_NV11,
MAKEFOURCC('N', 'V', '1', '1'), 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);

//o̓s
CDummySourceStream::CDummySourceStream(HRESULT *phr, CSource *pms)
 : CSourceStream(NAME("DummySourceStream"), phr, pms, L"out"),
   m_cmt(&MEDIATYPE_Video)
{
}

CDummySourceStream::~CDummySourceStream(void)
{
}

// o̓tH[}bgݒ肷
// ^ꂽfBA^Cvo͂
HRESULT CDummySourceStream::SetOutputMediaType(CMediaType *pMediaType)
{
	ASSERT(pMediaType);
	if(pMediaType->IsValid()){
		m_cmt = *pMediaType;
		return S_OK;
	}

	return E_FAIL;
}

//o̓tH[}bg񎦂
HRESULT CDummySourceStream::GetMediaType(CMediaType *pMediaType)
{
	ASSERT(m_cmt.IsValid());

	//炩ߐݒ肳ꂽtH[}bgB
	*pMediaType = m_cmt;

	return S_OK;
}

//s̃RlNṼtH[}bg`FbN
HRESULT CDummySourceStream::CheckMediaType(const CMediaType *pMediaType)
{
	//fBATu^CvłS_OKԂ
	//iXgChύX͖j
	if(pMediaType->subtype == m_cmt.subtype){
		return S_OK;
	}

	return CSourceStream::CheckMediaType(pMediaType);
}

//VIDEOINFOHEADER(2)  BITMAPINFOHEADER owp֐
BITMAPINFOHEADER *CDummySourceStream::GetBmiHeader(const CMediaType &cmt) const
{
	BITMAPINFOHEADER *pbmi;
	if (cmt.formattype == FORMAT_VideoInfo && cmt.cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmi = &reinterpret_cast<VIDEOINFOHEADER*>(cmt.pbFormat)->bmiHeader;
	} else if (cmt.formattype == FORMAT_VideoInfo2 && cmt.cbFormat >= sizeof(VIDEOINFOHEADER2)) {
		pbmi = &reinterpret_cast<VIDEOINFOHEADER2*>(cmt.pbFormat)->bmiHeader;
	} else {
		pbmi = NULL;
	}

	return pbmi;
}

//o̓s̃AP[^ݒ
HRESULT CDummySourceStream::DecideBufferSize(IMemAllocator *pAlloc,
	ALLOCATOR_PROPERTIES *pProp )
{
	CMediaType cmt;
	HRESULT hr = ConnectionMediaType(&cmt);
	if (FAILED(hr))
	{
		return hr;
	}

	ASSERT(cmt.formattype == FORMAT_VideoInfo 
		|| cmt.formattype == FORMAT_VideoInfo2);

	//TCY͓K
	BITMAPINFOHEADER *pbmi = GetBmiHeader(cmt);
	pProp->cbBuffer = DIBSIZE(*pbmi); 
	if (pProp->cbAlign == 0)
	{
		pProp->cbAlign = 1;
	}
	if (pProp->cBuffers == 0)
	{
		pProp->cBuffers = 1;
	}

	// AP[^ vpeBݒ肷B
	ALLOCATOR_PROPERTIES Actual;
	hr = pAlloc->SetProperties(pProp, &Actual);
	if (FAILED(hr)) 
	{
		return hr;
	}

	// ꍇAۂ̌ʂmFB
	if (pProp->cbBuffer > Actual.cbBuffer) 
	{
		return E_FAIL;
	}
	return S_OK;

}

//ɑTvɃf[^
HRESULT CDummySourceStream::FillBuffer(IMediaSample *pSamp)
{
	// _EXg[̃tH[}bgύXB
	CMediaType *pMT = NULL;
	HRESULT hr = pSamp->GetMediaType((AM_MEDIA_TYPE**)&pMT);
	if (hr == S_OK)	{
		DisplayType(NAME("FillBuffer():from DOWN"), pMT);

		// V^CvɂĎg̏o̓sɒʒmB
		SetMediaType(pMT);
		DeleteMediaType(pMT);
	}

	// ɂȂobt@ւ̃|C^擾B
	BYTE *pBuffer;
	hr = pSamp->GetPointer(&pBuffer);
	if (FAILED(hr))	{
		return hr;
	}

	//C^[[XtOA炩ߐݒ肳ꂽo̓fBA^Cv
	//ɂݒȆs
	VIDEOINFOHEADER2 *vif2 = reinterpret_cast<VIDEOINFOHEADER2*>(m_cmt.pbFormat);
	IMediaSample2 *pIm2 = NULL;
	hr = pSamp->QueryInterface(IID_IMediaSample2, (void**)&pIm2);
	if(SUCCEEDED(hr)){
		AM_SAMPLE2_PROPERTIES am2;
		hr = pIm2->GetProperties(offsetof(AM_SAMPLE2_PROPERTIES, dwSampleFlags), (BYTE*)&am2);
		if(SUCCEEDED(hr) && 0 != vif2->dwInterlaceFlags){
			if(vif2->dwInterlaceFlags & AMINTERLACE_1FieldPerSample){
				//C^[[u
				if(vif2->dwInterlaceFlags & AMINTERLACE_FieldPatField2Only){
					am2.dwSampleFlags = AM_VIDEO_FLAG_FIELD2;
				}else{
					am2.dwSampleFlags = AM_VIDEO_FLAG_FIELD1;
				}
			}else{
				//C^[[u
				if(vif2->dwInterlaceFlags & AMINTERLACE_Field1First){
					am2.dwSampleFlags = AM_VIDEO_FLAG_FIELD1FIRST;
				}else{
					am2.dwSampleFlags = AM_VIDEO_FLAG_INTERLEAVED_FRAME;
				}
			}
		}
		pIm2->SetProperties(offsetof(AM_SAMPLE2_PROPERTIES, dwSampleFlags), (BYTE*)&am2);
		pIm2->Release();
	}


	//obt@TCY
	LONG sz = pSamp->GetSize();

	//obt@ׂĂO[Ŗ߂
	FillMemory(pBuffer, sz, 128);

	//ۂ̃f[^ʒm
	pSamp->SetActualDataLength(sz);
	//L[t[łB
	pSamp->SetSyncPoint(TRUE);

	return S_OK;
}

//tB^̖{
CDummySource::CDummySource(void)
:CSource(NAME("DummySource"), NULL, GUID_NULL)
{
	//o̓s쐬
	HRESULT hr;
	new CDummySourceStream(&hr, this);
}

CDummySource::~CDummySource(void)
{
}

//For VMR7
// VMRVideoDesc  CMediaType ɕϊŃsɒʒm
HRESULT CDummySource::SetVMRVideoDesc(VMRVideoDesc *dsc)
{
	CMediaType cmt(&MEDIATYPE_Video);

	if(dsc->dwFourCC){
		//RGBȊȌꍇ
		FOURCCMap sub(dsc->dwFourCC);
		cmt.SetSubtype(&sub);
	}else{
		//RGB̏ꍇiAȂ悤j
		cmt.SetSubtype(&MEDIASUBTYPE_RGB32);
	}

	cmt.SetFormatType(&FORMAT_VideoInfo2);

	VIDEOINFOHEADER2 vif2;
	BITMAPINFOHEADER *pbmi = &vif2.bmiHeader;
	ZeroMemory(&vif2, sizeof(vif2));

	//VIDEOINFOHEADER2̐ݒ
	//t[[g
	vif2.AvgTimePerFrame = Int64x32Div32(UNITS,
		dsc->InputSampleFreq.dwDenominator,
		dsc->InputSampleFreq.dwNumerator, 0);
	vif2.dwPictAspectRatioX = dsc->dwSampleWidth;
	vif2.dwPictAspectRatioY = dsc->dwSampleHeight;

	if(dsc->SingleFieldPerSample){
		//C^[[uBob
		vif2.dwInterlaceFlags = 
			AMINTERLACE_IsInterlaced | 
			AMINTERLACE_1FieldPerSample |
			AMINTERLACE_DisplayModeBobOnly;
	}else{
		//C^[[uBob
		vif2.dwInterlaceFlags = 
			AMINTERLACE_IsInterlaced | 
			AMINTERLACE_Field1First |
			AMINTERLACE_DisplayModeBobOnly;
	}

	//BITMAPINFOHEADER
	pbmi->biSize = sizeof(BITMAPINFOHEADER);
	pbmi->biWidth = dsc->dwSampleWidth;
	pbmi->biHeight = dsc->dwSampleHeight;
	pbmi->biPlanes = 1;

	//Tu^Cv
	if(cmt.subtype == MEDIASUBTYPE_RGB32){
		//RGB32
		pbmi->biBitCount = 32;
	}else if(cmt.subtype == MEDIASUBTYPE_AYUV){
		//YUV4:4:4(packed)
		pbmi->biBitCount = 32;
	}else if(cmt.subtype == MEDIASUBTYPE_NV11){
		//YUV4:1:1(planer)
		pbmi->biBitCount = 16;
	}else if(cmt.subtype == MEDIASUBTYPE_YUY2
		|| cmt.subtype == MEDIASUBTYPE_UYVY)
	{
		//YUV4:2:2(packed)
		pbmi->biBitCount = 16;
	}else if(cmt.subtype == MEDIASUBTYPE_YVU9
		|| cmt.subtype == MEDIASUBTYPE_IF09)
	{
		//YUV4:1:0(planer)
		pbmi->biBitCount = 9;
	}else{
		//YUV4:2:0(planer)
		pbmi->biBitCount = 12;
	}

	pbmi->biCompression = dsc->dwFourCC;
	pbmi->biSizeImage = 
		(pbmi->biWidth * pbmi->biHeight * pbmi->biBitCount)/8;

	//o̓sɒʒmݒ
	if(cmt.SetFormat(reinterpret_cast<BYTE*>(&vif2), sizeof(vif2)))
	{
		return static_cast<CDummySourceStream*>
			(GetPin(0))->SetOutputMediaType(&cmt);
	}
		
	return E_FAIL;
}


//For VMR9
// VMR9VideoDesc  CMediaType ɕϊŃsɒʒm
HRESULT CDummySource::SetVMRVideoDesc(VMR9VideoDesc *dsc)
{
	CMediaType cmt(&MEDIATYPE_Video);

	if(dsc->dwFourCC){
		FOURCCMap sub(dsc->dwFourCC);
		cmt.SetSubtype(&sub);
	}else{
		//RGB
		cmt.SetSubtype(&MEDIASUBTYPE_RGB32);
	}

	cmt.SetFormatType(&FORMAT_VideoInfo2);

	VIDEOINFOHEADER2 vif2;
	BITMAPINFOHEADER *pbmi = &vif2.bmiHeader;
	ZeroMemory(&vif2, sizeof(vif2));

	//VIF2̐ݒ
	//t[[g
	vif2.AvgTimePerFrame = Int64x32Div32(UNITS,
		dsc->InputSampleFreq.dwDenominator,
		dsc->InputSampleFreq.dwNumerator, 0);
	vif2.dwPictAspectRatioX = dsc->dwSampleWidth;
	vif2.dwPictAspectRatioY = dsc->dwSampleHeight;

	//₷̂ŒӁI
	// Even 1st == top 1st == Field1First
	switch(dsc->SampleFormat)
	{
	case VMR9_SampleFieldInterleavedEvenFirst:
		vif2.dwInterlaceFlags = 
			AMINTERLACE_IsInterlaced | 
			AMINTERLACE_Field1First |
			AMINTERLACE_DisplayModeBobOnly;
		break;
	case VMR9_SampleFieldInterleavedOddFirst:
		vif2.dwInterlaceFlags = 
			AMINTERLACE_IsInterlaced | 
			AMINTERLACE_DisplayModeBobOnly;
		break;
	case VMR9_SampleFieldSingleEven:
		vif2.dwInterlaceFlags = 
			AMINTERLACE_IsInterlaced | 
			AMINTERLACE_1FieldPerSample |
			AMINTERLACE_FieldPatField1Only |
			AMINTERLACE_DisplayModeBobOnly;
		break;
	case VMR9_SampleFieldSingleOdd:
		vif2.dwInterlaceFlags = 
			AMINTERLACE_IsInterlaced | 
			AMINTERLACE_1FieldPerSample |
			AMINTERLACE_FieldPatField2Only |
			AMINTERLACE_DisplayModeBobOnly;
		break;
	case VMR9_SampleProgressiveFrame:
	default:
		break;
	}

	//BITMAP
	pbmi->biSize = sizeof(BITMAPINFOHEADER);
	pbmi->biWidth = dsc->dwSampleWidth;
	pbmi->biHeight = dsc->dwSampleHeight;
	pbmi->biPlanes = 1;

	//Tu^Cv
	if(cmt.subtype == MEDIASUBTYPE_RGB32){
		//RGB32
		pbmi->biBitCount = 32;
	}else if(cmt.subtype == MEDIASUBTYPE_AYUV){
		//YUV4:4:4(packed)
		pbmi->biBitCount = 32;
	}else if(cmt.subtype == MEDIASUBTYPE_NV11){
		//YUV4:1:1(planer)
		pbmi->biBitCount = 16;
	}else if(cmt.subtype == MEDIASUBTYPE_YUY2
		|| cmt.subtype == MEDIASUBTYPE_UYVY)
	{
		//YUV4:2:2(packed)
		pbmi->biBitCount = 16;
	}else if(cmt.subtype == MEDIASUBTYPE_YVU9
		|| cmt.subtype == MEDIASUBTYPE_IF09)
	{
		//YUV4:1:0(planer)
		pbmi->biBitCount = 9;
	}else{
		//YUV4:2:0(planer)
		pbmi->biBitCount = 12;
	}

	pbmi->biCompression = dsc->dwFourCC;
	pbmi->biSizeImage = 
		(pbmi->biWidth * pbmi->biHeight * pbmi->biBitCount)/8;

	//o̓sɒʒmݒ
	if(cmt.SetFormat(reinterpret_cast<BYTE*>(&vif2), sizeof(vif2)))
	{
		return static_cast<CDummySourceStream*>
			(GetPin(0))->SetOutputMediaType(&cmt);
	}
		
	return E_FAIL;
}

//Ls̃fBA^CvԂ
const CMediaType* CDummySource::GetMediaType(int n)
{
	return static_cast<CDummySourceStream*>(GetPin(n))->GetMediaType();
}
